;----------------------------------------------------------------------------
;
; File:        _tms9900.asm
; Date:        23-Feb-1998
; Programmer:  Marc Rousseau
;
; Description:
;
; Copyright (c) 1994-2000 Marc Rousseau, All Rights Reserved.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
;
; Revision History:
;
;----------------------------------------------------------------------------

	.386p
	IDEAL
	JUMPS
	MODEL	USE32 FLAT, CPP, OS2

	INCLUDE	"TMS9900.INC"

STRUC	sOpCode
  mnemonic	db      4 dup ( ? )
  opCode  	dw      ?
  mask		dw      ?
  format	dw	?
  function	dd	?
  clocks	dd	?
  count		dd	?
ENDS	sOpCode

STRUC	sLookUp
  opCode	dd	?
  size		dd	?
ENDS	sLookUp


	DATASEG

	EXTRN	_TimerHook	: PTR

	EXTRN	intLevel	: BYTE
	EXTRN	_ReadTrap	: PTR
	EXTRN	_WriteTrap	: PTR
	EXTRN	_LookUp		: sLookUp

	PUBLIC	_CpuMemory, _MemFlags
	PUBLIC  _InterruptFlag, _WorkspacePtr, _ProgramCounter, _Status
	PUBLIC  _InstructionCounter
	PUBLIC  _ClockCycleCounter
	PUBLIC	CpuMemoryW, CpuMemoryB

_InterruptFlag          db      -1

_WorkspacePtr		dw	0
_ProgramCounter		dw	0
_Status			dw	0

_InstructionCounter	dd	0
_ClockCycleCounter	dd	0

stopFlag		dd	0
runFlag			dd	0

	UDATASEG


LABEL	CpuMemoryW	WORD
LABEL	CpuMemoryB	BYTE

_CpuMemory		db	00010000h dup (?)
_MemFlags		db	00010000h dup (?)

	CODESEG

	EXTRN	_ExecuteGPL : NEAR
	EXTRN	_InvalidOpcode : NEAR
	EXTRN   ContextSwitch  : NEAR
	EXTRN   SetStatus : NEAR
	EXTRN   GetStatus : NEAR

	PUBLIC	_Run, _Stop, _Step, _IsRunning

	PUBLIC	ExecuteInstruction
	PUBLIC	GetArgumentB, GetArgumentW
	PUBLIC	 ReadMemoryB,   ReadMemoryW
	PUBLIC	_ReadMemoryB,  _ReadMemoryW
	PUBLIC	 WriteMemoryB,  WriteMemoryW
	PUBLIC	_WriteMemoryB, _WriteMemoryW

PROC	GetArgumentB

	mov	ecx, eax
	and	ecx, 0000000Fh
	lea	ecx, [ _WP_ + ecx * 2 ]
	test	eax, 00000030h
	je	@@done
	mov     edx, ecx
	movzx	ecx, [ CpuMemoryW + ecx ]
	test	eax, 00000020h
	je	@@done
	test	eax, 00000010h
	je	@@indexed
	inc	[ CpuMemoryW + edx ]
	jmp	@@done

@@indexed:
	cmp	_WP_, edx
	sbb	edx, edx
	and	ecx, edx
	add	cx, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
@@done:
	xor	ecx, 1
	ret

ENDP	GetArgumentB

PROC	GetArgumentW

	mov	ecx, eax
	and	ecx, 0000000Fh
	lea	ecx, [ _WP_ + ecx * 2 ]
	test	eax, 00000030h
	je	@@done
	mov     edx, ecx
	movzx	ecx, [ CpuMemoryW + ecx ]
	test	eax, 00000020h
	je	@@done
	test	eax, 00000010h
	je	@@indexed
	add	[ CpuMemoryW + edx ], 2
	jmp	@@done

@@indexed:
	cmp	_WP_, edx
	sbb	edx, edx
	and	ecx, edx
	add	cx, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
@@done:
	and	ecx, 0000FFFEh
	ret

ENDP	GetArgumentW

PROC	ReadMemoryB

	movsx	ebx, [ CpuMemoryB + ecx ]
	ret

ENDP	ReadMemoryB

PROC	ReadMemoryW

	movsx	ebx, [ CpuMemoryW + ecx ]
	ret

ENDP	ReadMemoryW

PROC	_ReadMemoryB

	movsx	ebx, [ CpuMemoryB + ecx ]
	test	[ _MemFlags + ecx ], MEMFLG_READ
	je	@@MemOK
	CallTrapByte	_ReadTrap
	movsx	ebx, bl
@@MemOK:
	ret

ENDP	_ReadMemoryB

PROC	_ReadMemoryW

	movzx	ebx, [ CpuMemoryW + ecx ]
	test	[ _MemFlags + ecx ], MEMFLG_READ
	je	@@MemOK
	CallTrapWord	_ReadTrap
	movzx	ebx, bx
@@MemOK:
	ret

ENDP	_ReadMemoryW

PROC	WriteMemoryB

	mov	[ CpuMemoryB + ecx ], bl
	ret

ENDP	WriteMemoryB

PROC	WriteMemoryW

	mov	[ CpuMemoryW + ecx ], bx
	ret

ENDP	WriteMemoryW

PROC	_WriteMemoryB

	test	[ _MemFlags + ecx ], ( MEMFLG_WRITE OR MEMFLG_ROM )
	je	@@Done
	test	[ _MemFlags + ecx ], MEMFLG_WRITE
	je	@@MemOK
	CallTrapByte	_WriteTrap
@@MemOK:
	test	[ _MemFlags + ecx ], MEMFLG_ROM
	jne	@@ROM
@@Done:
	mov	[ CpuMemoryB + ecx ], bl
@@ROM:
	ret

ENDP	_WriteMemoryB

PROC	_WriteMemoryW

	test	[ _MemFlags + ecx ], ( MEMFLG_WRITE OR MEMFLG_ROM )
	je	@@Done
	test	[ _MemFlags + ecx ], MEMFLG_WRITE
	je	@@MemOK
	CallTrapWord	_WriteTrap
@@MemOK:
	test	[ _MemFlags + ecx ], MEMFLG_ROM
	jne	@@ROM
@@Done:
	mov	[ CpuMemoryW + ecx ], bx
@@ROM:
	ret

ENDP	_WriteMemoryW

PROC	ExecuteInstruction

	mov	ebx, eax
	shr	ebx, 12
	lea	ebx, [ _LookUp + ebx * 8 ]
	mov	edi, [ ebx + sLookUp.opCode ]
	mov	ecx, [ ebx + sLookUp.size ]
	jecxz	@Match
	inc     ecx
@Retry:
	movzx	ebx, [ edi + sOpCode.mask ]
	and	ebx, eax
	cmp	bx, [ edi + sOpCode.opCode ]
	je	@Match
	add	edi, SIZE sOpCode
	loop	@Retry
	call	_InvalidOpcode
	ret
@Match:
	mov	ebx, [ edi + sOpCode.clocks ]
	add	[ _ClockCycleCounter ], ebx
	inc	[ edi + sOpCode.count ]
	call	[ edi + sOpCode.function ]
	ret

ENDP	ExecuteInstruction

PROC	_Step

	inc	[ runFlag ]
	pushad
	movzx	ebp, [ _WorkspacePtr ]
	movzx	esi, [ _ProgramCounter ]
	movzx	edx, [ _Status ]

	call	SetStatus

	call	CheckInterrupt
	movzx	eax, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
	call	ExecuteInstruction
	inc	[ _InstructionCounter ]

        cmp	[ _TimerHook ], 0
        je	@@Continue
        mov	eax, [ _InstructionCounter ]
        and	eax, 0FFh
        jne	@@Continue
        pushad
        call	[ _TimerHook ]
        popad

@@Continue:

	call	GetStatus

	mov	[ _WorkspacePtr ], bp
	mov	[ _ProgramCounter ], si
	mov	[ _Status ], dx
	popad
	dec	[ runFlag ]
	xor	eax,eax
	cmp	[ stopFlag ],0
        je	@@Done
	dec	[ stopFlag ]
        inc	eax
@@Done:
	ret

ENDP	_Step

PROC	_Run

	inc	[ runFlag ]
	pushad
	movzx	ebp, [ _WorkspacePtr ]
	movzx	esi, [ _ProgramCounter ]
	movzx	edx, [ _Status ]

	call	SetStatus

@@Forever:

	call	CheckInterrupt
;	cmp	_PCw_, 0070h
;	jne	@@NormalCode
;	pushad
;	call	_ExecuteGPL
;	cmp	eax, 0
;	je	@@NoGPL
;	popad
;	jmp	@@CheckTimer

@@NoGPL:

;	popad

@@NormalCode:

	movzx	eax, [ CpuMemoryW + _PC_ ]
	mov	[ _ProgramCounter ], _PCw_
	add	_PCw_, 2
	call	ExecuteInstruction
	inc	[ _InstructionCounter ]

@@CheckTimer:

        cmp	[ _TimerHook ], 0
        je	@@Continue
        mov	eax, [ _InstructionCounter ]
        and	eax, 0FFh
        jne	@@Continue
        pushad
        call	[ _TimerHook ]
        popad

@@Continue:

	cmp	[ stopFlag ], 0
	je	@@Forever

	call	GetStatus

	mov	[ _WorkspacePtr ], bp
	mov	[ _ProgramCounter ], si
	mov	[ _Status ], dx
	dec	[ stopFlag ]
	popad
	dec	[ runFlag ]
	ret

ENDP	_Run

PROC	_Stop

	inc	[ stopFlag ]
	ret

ENDP	_Stop

PROC	_IsRunning

	mov	eax, [ runFlag ]
	ret

ENDP	_IsRunning

PROC    CheckInterrupt

	movzx   ecx, [ _InterruptFlag ]
	cmp     cl, [ intLevel ]
	ja      @@Done

	mov     [ _InterruptFlag ], -1
	movzx   eax, [ CpuMemoryW + ecx * 4 ]
	movzx   ebx, [ CpuMemoryW + ecx * 4 + 2 ]
	call    ContextSwitch

	cmp     cl, 0
	je      @@Done
	dec     cl
	mov     [ intLevel ], cl

@@Done:
	ret
ENDP    CheckInterrupt

	END
